<?php
namespace Teknisa\EST\Modules\EstoqueCego\Factories;

use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Est90000PerfilDeOperadoresDoInventarioCegoFactory {
    protected $connection;
    protected $entityManager;

    public function __construct ($entityManager) {
        $this->connection = $entityManager->getConnection();
		$this->entityManager = $entityManager;
    }
    
    public function getCDGRUPOPER($IDAUTGRUPOP) {
        $params = [":IDAUTGRUPOP" => $IDAUTGRUPOP];
        
        $sql = "SELECT CDGRUPOPER
                  FROM AUTGRUPOP
                 WHERE IDAUTGRUPOP = :IDAUTGRUPOP";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $result = $std->fetch();
        
        return $result['CDGRUPOPER'];
    }
    
    public function checkField($CDOPERADOR,$field) {
        $params = [ 
            ":CDGRUPOPER" => $this->getCDGRUPOPER(substr($field, -4)),
            ":CDOPERADOR" => $CDOPERADOR
        ];
        
        $sql = "SELECT G.CDGRUPOPER
                  FROM OPERGRUPOP G
                 WHERE G.CDGRUPOPER = :CDGRUPOPER
                   AND G.CDOPERADOR = :CDOPERADOR";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $result = $std->fetch();
    }
    
    public function saveOperation($params) {
        $sql = "INSERT INTO OPERGRUPOP (CDGRUPOPER, CDOPERADOR)
                     VALUES (:CDGRUPOPER, :CDOPERADOR)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateMenu($params) {
        $signal = $params[":IDMENUPRINOP"] === "S"?'= ':'<> ';
        
        $sql = "UPDATE OPERGRUPOP
                   SET IDMENUPRINOP = :IDMENUPRINOP
                 WHERE CDOPERADOR   = :CDOPERADOR
                   AND CDGRUPOPER   " .$signal. ":CDGRUPOPER";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function deleteOperation($params) {
        $sql = "DELETE FROM OPERGRUPOP
                 WHERE CDOPERADOR = :CDOPERADOR 
                   AND CDGRUPOPER = :CDGRUPOPER";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getAbleGroups() {
        $sql = "SELECT CDGRUPOPER, IDAUTGRUPOP
                  FROM AUTGRUPOP
                 WHERE IDAUTGRUPOP IN ('GEST', 'GGER', 'GAUD')";
        $std = $this->connection->prepare($sql);
        $std->execute();
        
        return $result = $std->fetchAll();
    }
}